//  BaseMeth.js
//  <project>
//  查询测点结果集方法  参数：StrMonitorType测点类型（01，02，03）；
//  Created by Administrator on 2016-03-07.
//  Copyright 2016 Administrator. All rights reserved.
function GisQueryPoint(StrMonitorType) {
	plus.nativeUI.showWaiting("正在加载...", {
		padlock: false
	});
	var URL = getHostUrl("GisHandle_EclipQueryData?GisMonitorType=" + StrMonitorType);
	$.ajax({
		type: 'post',
		dataType: 'JSONP',
		url: URL,
		jsonp: "callback",
		success: function(result) {
			if(result) {
				if(result.isSuccess) {
					//alert(result.result[0].length);
					addClusters(result.result[0], result.result[1]);
				} else {}
			} else {
				mui.toast("读取测点信息失败，请稍后重试。");
			}
		},
		error: function(XmlHttpRequest, textStatus, errorThrown) {
			mui.toast("服务连接失败，请稍后重试。");
		}
	});
}

//  BaseMeth.js
//  <project>
//  主页面“定位”按钮使用
//  Created by Administrator on 2016-04-28.
//  Copyright 2016 Administrator. All rights reserved.
function SelfLocation() {
	//document.getElementById('SelfLocation').src = '../../../Images/Gis/SelfLocation2.png';
	//手机设备不支持
	//if(navigator.onLine) {
	//	alert('网络连接正常');
	//} else {
	//	lert('没有网络连接');
	//}
	//一次性获取位置的请求
	plus.nativeUI.showWaiting("正在加载...", {
		padlock: false
	});
	if(navigator.geolocation) {
		navigator.geolocation.getCurrentPosition(locationSuccess, locationError, {
			// 指示浏览器获取高精度的位置，默认为false  
			enableHighAcuracy: true,
			// 指定获取地理位置的超时时间，默认不限时，单位为毫秒  
			timeout: 5000,
			// 最长有效期，在重复获取地理位置时，此参数指定多久再次获取位置。  
			maximumAge: 0
		});
	} else {
		mui.toast("您的设备不支持地理定位！ ");
	}
	//document.getElementById('SelfLocation').src = '../../../Images/Gis/SelfLocation1.png';
}

function locationError(error) {
	plus.nativeUI.closeWaiting();
	switch(error.code) {
		case error.PERMISSION_DENIED:
			mui.toast('请打开GPS设置。');
			break;
		case error.TIMEOUT:
			mui.toast("发生超时！请再试一次！");
			//mui.toast("请检查网络和GPS设置。");
			break;
		case error.POSITION_UNAVAILABLE:
			mui.toast('无法检测到你的位置。');
			break;
		case error.UNKNOWN_ERROR:
			mui.toast('发生未知错误。');
			break;
	}
}

function locationSuccess(position) {
	plus.nativeUI.closeWaiting();
	//alert('GPS定位完成，' + position.coords.latitude + ',' + position.coords.longitude);
	LocationLayer.clear();
	map.infoWindow.hide();
	var mercator1 = gcj_encrypt(position.coords.latitude, position.coords.longitude);
	//console.log("定位" + mercator1.lat + "," + mercator1.lon);
	//转换成百度坐标
	var baiduMercator = bd_encrypt(mercator1.lat, mercator1.lon);
	//console.log(baiduMercator.lat + "," + baiduMercator.lon);

	//alert("WGS-84 to GCJ-02   " + mercator1.lon + ',' + mercator1.lat);
	var point = new esri.geometry.Point(mercator1.lon, mercator1.lat); //new esri.SpatialReference({"wkid": 4326})
	var graphic = new esri.Graphic(point, new esri.symbol.PictureMarkerSymbol("../../../Images/Gis/SelfLocation2.png", 25, 25), null, null);
	LocationLayer.add(graphic);
	map.setZoom(10);
	map.centerAt(point);

	//调用百度地图API
	var x = baiduMercator.lat;
	var y = baiduMercator.lon;
	//配置Baidu Geocoding API
	var url = "http://api.map.baidu.com/geocoder/v2/?ak=FE2cd6cb35afe2584e5f7525fdeea6c8" +
		"&callback=renderReverse" +
		"&location=" + x + "," + y +
		"&output=json" +
		"&pois=0";
	$.ajax({
		type: "GET",
		dataType: "jsonp",
		url: url,
		success: function(json) {
			if(json == null || typeof(json) == "undefined") {
				return;
			}
			if(json.status != "0") {
				return;
			}
			setAddress(json.result.addressComponent);
		},
		error: function(XMLHttpRequest, textStatus, errorThrown) {
			alert("[x:" + x + ",y:" + y + "] 百度地图服务无响应，地址位置获取失败。");
		}
	});
}

function setAddress(json) {
	//省
	var province = json.province;
	//市
	var city = json.city;
	//区
	var district = json.district;
	//街道
	var street = json.street;
	//街道号
	var street_number = json.street_number;
	//方向
	var direction = json.direction;
	//距离
	var distance = json.distance.length > 0 ? json.distance + '米' : '';
	province = province.replace('市', '');
	var Streetvalue = province + city + district + street + street_number + direction + distance;
	//position.style.color = 'black';
	mui.toast(Streetvalue);
	//alert(Streetvalue);
	//alert(JSON.stringify(json));
}

var PI = 3.14159265358979324;
var x_pi = 3.14159265358979324 * 3000.0 / 180.0;
//WGS-84 to GCJ-02
function gcj_encrypt(wgsLat, wgsLon) {
	if(this.outOfChina(wgsLat, wgsLon))
		return {
			'lat': wgsLat,
			'lon': wgsLon
		};

	var d = this.delta(wgsLat, wgsLon);
	return {
		'lat': wgsLat + d.lat,
		'lon': wgsLon + d.lon
	};
}

function outOfChina(lat, lon) {
	if(lon < 72.004 || lon > 137.8347)
		return true;
	if(lat < 0.8293 || lat > 55.8271)
		return true;
	return false;
}

function delta(lat, lon) {
	// Krasovsky 1940
	//
	// a = 6378245.0, 1/f = 298.3
	// b = a * (1 - f)
	// ee = (a^2 - b^2) / a^2;
	var a = 6378245.0; //  a: 卫星椭球坐标投影到平面地图坐标系的投影因子。
	var ee = 0.00669342162296594323; //  ee: 椭球的偏心率。
	var dLat = this.transformLat(lon - 105.0, lat - 35.0);
	var dLon = this.transformLon(lon - 105.0, lat - 35.0);
	var radLat = lat / 180.0 * this.PI;
	var magic = Math.sin(radLat);
	magic = 1 - ee * magic * magic;
	var sqrtMagic = Math.sqrt(magic);
	dLat = (dLat * 180.0) / ((a * (1 - ee)) / (magic * sqrtMagic) * this.PI);
	dLon = (dLon * 180.0) / (a / sqrtMagic * Math.cos(radLat) * this.PI);
	return {
		'lat': dLat,
		'lon': dLon
	};
}

function transformLat(x, y) {
	var ret = -100.0 + 2.0 * x + 3.0 * y + 0.2 * y * y + 0.1 * x * y + 0.2 * Math.sqrt(Math.abs(x));
	ret += (20.0 * Math.sin(6.0 * x * this.PI) + 20.0 * Math.sin(2.0 * x * this.PI)) * 2.0 / 3.0;
	ret += (20.0 * Math.sin(y * this.PI) + 40.0 * Math.sin(y / 3.0 * this.PI)) * 2.0 / 3.0;
	ret += (160.0 * Math.sin(y / 12.0 * this.PI) + 320 * Math.sin(y * this.PI / 30.0)) * 2.0 / 3.0;
	return ret;
}

function transformLon(x, y) {
	var ret = 300.0 + x + 2.0 * y + 0.1 * x * x + 0.1 * x * y + 0.1 * Math.sqrt(Math.abs(x));
	ret += (20.0 * Math.sin(6.0 * x * this.PI) + 20.0 * Math.sin(2.0 * x * this.PI)) * 2.0 / 3.0;
	ret += (20.0 * Math.sin(x * this.PI) + 40.0 * Math.sin(x / 3.0 * this.PI)) * 2.0 / 3.0;
	ret += (150.0 * Math.sin(x / 12.0 * this.PI) + 300.0 * Math.sin(x / 30.0 * this.PI)) * 2.0 / 3.0;
	return ret;
}

//GCJ-02 to BD-09
function bd_encrypt(gcjLat, gcjLon) {
	var x = gcjLon,
		y = gcjLat;
	var z = Math.sqrt(x * x + y * y) + 0.00002 * Math.sin(y * this.x_pi);
	var theta = Math.atan2(y, x) + 0.000003 * Math.cos(x * this.x_pi);
	bdLon = z * Math.cos(theta) + 0.0065;
	bdLat = z * Math.sin(theta) + 0.006;
	return {
		'lat': bdLat,
		'lon': bdLon
	};
}

//  BaseMeth.js
//  <project>
//  主页面“默认范围”按钮使用
//  Created by Administrator on 2016-04-28.
//  Copyright 2016 Administrator. All rights reserved.
function InitLocation() {
	//document.getElementById('InitLocation').src = '../../../Images/Gis/InitLocation2.png';
	map.setExtent(startExtent);
	//document.getElementById('InitLocation').src = '../../../Images/Gis/InitLocation1.png';
}
//获取位置名称-任加
function setDizhi(json) {
	//区
	var district = json.district;
	//街道
	var street = json.street;
	//街道号
	var street_number = json.street_number;
	//方向
	var direction = json.direction;
	//距离
	var distance = json.distance.length > 0 ? json.distance + '米' : '';
	var Streetvalue = district + street + street_number + direction + distance;
	return Streetvalue;
}